$(document).ready($app.init);

/*INDEX*/
$(document).on('click', '#addTimer', function(){
    if(!$('#addTimerRow').length) {
        let input = '<input type="text" class="form-control" id="projectName" placeholder="название проекта" />';
        let projects = '';
        if($app.projects.length > 0) {
            for (i in $app.projects) projects += '<option value="'+$app.projects[i]+'">'+ $app.projects[i] + '</option>';
            projects = '<select class="form-control" id="projectName">'+projects+'<option value="newprojectsenteringvalue">Новый проект</option></select>'
        } else projects = input;
        $('#myList').append($view.templates.timerAdd.replace('{projects}', projects));
        if ($('select#projectName').length) $('select#projectName').change(function(){
            if ($(this).val() == 'newprojectsenteringvalue') {
                $(this).after(input).remove();
                $(this).remove();
            }
        });
    }
});

$(document).on('click', '[data-timer-add]', function(){
    if ($('#timerName').val() == '' || $('#projectName').val() == '') {
        alert('Необходимо заполнить все поля');
        return false;
    }

    let timer = new Timer({name:$('#timerName').val(), project:$('#projectName').val()});
    $app.timers[timer.id] = timer;
    $app.storage[timer.id] = $app.timers[timer.id].getOptions();
    $app.timers[timer.id].draw();
    $app.timers[timer.id].save();
    $('#addTimerRow').remove();
});

$(document).on('click', '[data-timer-delete]', function(){
    $app.timers[$(this).closest('[data-timer-id]').attr('data-timer-id')].delete();
});

$(document).on('click', '[data-timer-control]', function(){
    let id = $(this).closest('[data-timer-id]').attr('data-timer-id');
    if($app.timers[id].status === false){
        $app.timers[id].start();
    } else if($app.timers[id].status === true){
        $app.timers[id].stop();
    }
});

/*OPTIONS*/
$(document).on('click', '#exportSettings', function(){
    const fs = require('fs');
    const path = require('path');
    ipcRenderer.once('export-bd-reply', function(e, bd){
        bd = JSON.stringify(bd);
        dialog.showSaveDialog(function(filePath){
            if (filePath === undefined){
                alert('Необходимо выбрать файл или указать имя нового файла!');
                return false;
            };
            let tmpPath = filePath.split(path.sep);
            let tmpName = tmpPath[tmpPath.length - 1];
            if (tmpName.indexOf('.') != -1){
                tmpName = tmpName.split('.');
                if (tmpName[tmpName.length - 1] != 'json') tmpName[tmpName.length - 1] = 'json';
                tmpName = tmpName.join('.');
            } else if(tmpName.indexOf('.') == -1) tmpName += '.json';
            tmpPath[tmpPath.length - 1] = tmpName;
            tmpPath = tmpPath.join(path.sep);
            fs.writeFile(filePath, bd, function(err){
                if (err) alert('Ошибка сохранения файла: '+ err.message);
                else info('Файл проекта сохранен успешно');
            });
        });
    });
    ipcRenderer.send('export-bd');
});

$(document).on('click', '#importSettings', function(){
    let fs = require('fs');
    confirm('Вы уверены, что хотите импортировать базу данных? все текущие проекты будут утеряны!', function(){
        dialog.showOpenDialog({filters:[{ name: 'Json files', extensions: ['json'] }]}, function(filePath){
            if(filePath === undefined){
                alert('Необходимо выбрать файл');
                return false;
            };
            fs.readFile(filepath, $app.options.encoding, function(err, data){
                if (err){
                    alert('Ошибка чтения файла:' + err.message);
                    return false;
                };
                if (isJSON(data)) data = JSON.parse(data);
                else {
                    alert('Файл неверного формата');
                    return false;
                }
                if (!data.timers) {
                    alert('В выбранном файле нет данных о проектах');
                    return false;
                };
                ipcRenderer.once('import-bd-error', function(){
                    alert('Произошла ошибка, база данных не была сохранена');
                });
                ipcRenderer.send('import-bd', data);
            });
        });
    });
});

/*ARCHIVE*/
$(document).on('click', '#myArchive span i.fa-close', function(){
    let $this = $(this);
    confirm('Вы уверены что хотите удалить проект? Все данные по его работам (включая активные) будут утеряны', function(){
        let ttd = [];
        for(i in $app.timers) {
            if ($app.timers[i].project == $this.attr('data-project')) ttd.push(i);
        }
        ipcRenderer.once('delete-project-reply', function(e, status){
            if(status == 'success') $this.closest('.row').remove();
            else alert('Произошла ошибка, перезагрузите приложение и попробуйте еще раз.');
        });
        ipcRenderer.send('delete-project', ttd);
    });
});
