let Timer = (function()
{
    function Timer(data)
    {
        data.total = data.total ? data.total : 0;
        data.id = data.id ? data.id : $app.getNewId();
        data.archive = data.archive ? data.archive : false;
        for(i in data) this[i] = data[i];
        this.status = false;
        this.timer = false;
    };

    Timer.prototype =
    {
        save: function()
        {
            ipcRenderer.send('save-timer', this.getOptions());
            ipcRenderer.once('save-timer-reply', function(event, data) {
                if(data['save-status'] == 'error') alert('Ошибка сохранения таймера: '+ data.name);
            });
        },
        start: function()
        {
            for(t in $app.timers){
                if($app.timers[t].status === true ) $app.timers[t].stop($('[data-timer-id="'+t+'"]'));
            }
            $('[data-timer-id="'+this.id+'"]').find('[data-timer-control] span').removeClass('btn-success').addClass('btn-info');
            $('[data-timer-id="'+this.id+'"]').find('[data-timer-control] span i').removeClass('fa-play').addClass('fa-stop');
            this.status = true;
            let i = 0;
            let this_ = this;
            this.timer = setInterval(function(){
                i++;
                this_.total++;
                $app.calculate();
                let total = $app.convert(this_.total);
                $('[data-timer-id="'+this_.id+'"]').find('[data-timer-time]').text(total);
                if(i == 10) {
                    this_.save();
                    i = 0;
                };
            }, 1000);
        },
        stop: function()
        {
            $('[data-timer-id="'+this.id+'"]').find('[data-timer-control] span').removeClass('btn-info').addClass('btn-success');
            $('[data-timer-id="'+this.id+'"]').find('[data-timer-control] span i').removeClass('fa-stop').addClass('fa-play');
            this.status = false;
            clearInterval(this.timer);
        },
        draw: function(){
            let data = this.getOptions();
            data.total = $app.convert(data.total);
            $('#myList').append($view.draw($view.templates.timerDraw, data))
        },
        getOptions: function(){
            return {id: this.id, name: this.name, total: this.total, project: this.project, archive: this.archive};
        },
        delete: function(){
            if(this.status === true) this.stop();
            delete $app.timers[this.id];
            this.archive = true;
            this.save();
            $app.storage[this.id] = this.getOptions();
            $('[data-timer-id="'+this.id+'"]').remove();
            $app.calculate();
        }
    };

    return Timer;
})();
